<template>
  <input
    v-if="editable"
    :type="type"
    :placeholder="placeholder"
    :value="value"
    @input="$emit('input', $event)"
    :style="{ fontSize: `${size}px` }"
  />
  <p v-else :style="{ fontSize: `${size}px` }">
    <slot />
  </p>
</template>

<script>
export default {
  props: {
    type: {
      type: String,
      default: 'text'
    },
    placeholder: String,
    value: [String, Number],
    size: {
      type: Number,
      default: 16
    },
    editable: {
      type: Boolean,
      default: false
    }
  }
};
</script>

<style lang="scss">
$dark: #212121;
$light: #fafafa;

input {
  border: 0;
  padding: 0;
  background-color: transparent;
  font-family: 'Nunito';
  font-weight: bold;
  font-size: 16px;
  text-transform: uppercase;
  text-overflow: ellipsis;
  text-align: center;
  color: $dark;
  caret-color: $light;
  width: 100%;

  &[type='number'] {
    &::-webkit-inner-spin-button,
    &::-webkit-outer-spin-button {
      -webkit-appearance: none;
      margin: 0;
    }
  }

  &:focus {
    outline: 0;
  }

  &::placeholder {
    color: $light;
  }
}

p {
  margin: 0;
  text-overflow: ellipsis;
  white-space: nowrap;
  overflow: hidden;
}
</style>
